:root {
    --input-height: 3rem;
    --input-font-size: 1.2rem;
    --config-preview-saturation: 2;
}

.title-text {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
}

.workflow-title {
    align-content: center;
    font-size: 1.5rem;
    overflow: hidden;
    overflow-wrap: anywhere;
}

.edit-button-container {
    width: 1.5rem;
    height: 1.5rem;
    color: var(--text-primary-color);
    background-color: var(--background-tertiary-color);
    padding: 0.75rem;
    border-radius: 0.5rem;
    user-select: none;
    aspect-ratio: 1/1;
    margin-left: 0.5rem;
}

.edit-button-container .icon {
    width: 100%;
    height: 100%;
}

.inputs-container {
    display: grid;
    grid-template-columns: 1fr;
    grid-gap: 1rem 0.5rem;
}

@media screen and (min-width: 420px) {
    .inputs-container {
        grid-template-columns: repeat(auto-fit, minmax(400px, 1fr));
    }
}

.workflow-input-container label {
    display: block;
    padding-bottom: 0.3ch;
    font-size: 1.2rem;
}

.workflow-input {
    flex: 1;
    width: 100%;
    box-sizing: border-box;
    background-color: var(--background-tertiary-color);
    color: var(--text-secondary-color);
    border: 0;
    padding: 0.5rem;
    border-radius: 0.5rem;
    height: var(--input-height);
    font-size: var(--input-font-size);
    transition: background-color 0.25s ease;
}

.workflow-input:focus {
    outline: none;
    background-color: var(--background-secondary-color);
}

textarea.workflow-input {
    height: 5rem;
    resize: vertical;
    font-size: 1rem;
    border-radius: 0.5rem 0.5rem 0 0.5rem;
    min-height: 2.2rem;
}

.inner-input-wrapper {
    display: flex;
    flex-direction: row;
}

.workflow-input.has-additional-button {
    /* styles for workflow-input if there is an additional button */
    border-radius: 0.5rem 0 0 0.5rem;
}

.additional-input-buttons-container {
    display: flex;
    flex-direction: row;
}

.additional-input-buttons-container > span {
    justify-content: center;
    align-items: center;
    user-select: none;
    box-sizing: border-box;
    width: var(--input-height);
    height: var(--input-height);
    border: 0;
    padding: 0;
    background-color: var(--background-tertiary-color);
    color: var(--text-secondary-color);
    font-size: var(--input-font-size);
}

.additional-input-buttons-container > span:last-child {
    display: flex;
    border-radius: 0 0.5rem 0.5rem 0;
    justify-content: center;
    align-items: center;
}

.randomise-now-button {
    display: none;
    font-size: 1.5rem !important;
}

.randomise-input-toggle::before {
    content: '🎲';
}

.randomise-buttons-container.randomise-off > .randomise-now-button {
    display: flex;
}

.randomise-buttons-container.randomise-off > .randomise-input-toggle::before {
    content: '🔒';
}

.randomise-buttons-container.randomise-off > .randomise-input-toggle {
    background-color: var(--background-secondary-color);
}

.workflow-input-container.has-image-upload .inner-input-wrapper {
    flex-direction: column;
}

.workflow-input-container .file-input {
    display: none;
}

.workflow-input-container .file-input-label {
    height: var(--input-height);
    background-color: var(--background-tertiary-color);
    padding: 0;
    border: 0;
    border-radius: 0.5rem;
    margin: 0.5rem 0;
    box-sizing: border-box;
}

.input-image-preview {
    width: 100%;
    height: 100%;
    object-fit: contain;
    border-radius: 0.5rem;
}

.workflow-input-container .file-input-label:active {
    transform: scale(0.95);
}

.workflow-input-container .file-input-label > span {
    height: 100%;
    width: 100%;
}

.run-button-wrapper {
    margin: 1rem 0;
    height: 3rem;
    width: 100%;
    box-sizing: border-box;
    padding: 1px;
    background: var(--accent-gradient);
    border-radius: 0.5rem;
}

.run-button-wrapper:active {
    filter: brightness(0.75);
}

.run-workflow {
    width: 100%;
    height: 100%;
    background-color: var(--background-secondary-color);
    color: var(--text-primary-color);
    border: 0;
    border-radius: 0.5rem;
    font-size: 1.5rem;
    user-select: none;
}

.cancel-run-button {
    width: 100%;
    height: 3rem;
    background-color: var(--background-secondary-color);
    display: flex;
    justify-content: center;
    align-items: center;
    text-align: center;
    border-radius: 0.5rem;
    border: 0;
    color: var(--text-primary-color);
    margin-bottom: 1rem;
    font-size: 1.1rem;
}

.cancel-run-button.disabled {
    filter: brightness(0.75);
}

.output-images-container {
    width: 100%;
}

.output-images-container a {
    text-decoration: none;
}

.output-image {
    width: 100%;
    border-radius: 0.5rem;
    margin-bottom: 0.5rem;
}

.previous-outputs-container {
    width: 100%;
    background-color: var(--background-tertiary-color);
    border-radius: 0.5rem;
    margin-bottom: 0.5rem;
}

.previous-outputs-toggler {
    padding: 0.5rem;
    border-radius: 0.5rem;
    text-align: center;
    cursor: pointer;
    user-select: none;
    font-size: 1.2rem;
    font-weight: bold;
    border-bottom: 1px solid var(--background-primary-color);
    display: flex;
    justify-content: space-evenly;
}

.previous-outputs-toggler-icon {
    transition: transform 0.5s ease;
}

.previous-outputs-toggler-icon.open {
    transform: rotateX(180deg);
}

.previous-outputs-list {
    overflow: hidden;
    height: auto;
    opacity: 1;
    padding: 0.5rem;
    box-sizing: border-box;
    border-radius: 0 0 0.5rem 0.5rem;
    transition:
        height 0.5s ease,
        opacity 0.5s ease,
        padding 0.5s ease;
}

.previous-outputs-list.expanding {
    height: 0px;
    opacity: 0;
    padding-top: 0;
    padding-bottom: 0;
}

.previous-outputs-list.collapsing {
    height: 0px;
    opacity: 0;
    padding-top: 0;
    padding-bottom: 0;
}

.previous-outputs-list.hidden {
    display: none;
    height: 0;
    opacity: 0;
}

.previous-output-item {
    display: inline-block;
    margin-bottom: 0.5rem;
}

.previous-output-item:last-child {
    margin-bottom: 0;
}

.previous-output-img {
    width: 100%;
    height: auto;
    border-radius: 0.5rem;
}

.progress-bar-label {
    margin: 0.5rem 0;
    user-select: none;
}

.total-images-progress,
.current-image-progress {
    width: 100%;
    height: 2.5rem;
    background-color: var(--background-secondary-color);
    margin: 0.5rem 0;
    border-radius: 0.5rem;
}

.progress-bar .progress-bar-inner {
    border-radius: 0.5rem;
    width: 0%;
    height: 100%;
    background: var(--accent-gradient);
    transition: width 0.5s ease;
}

.progress-bar .progress-bar-text {
    position: absolute;
    height: 2.5rem;
    display: flex;
    align-items: center;
    font-size: 1.5rem;
    padding-left: 0.5rem;
    user-select: none;
}

.image-placeholder-hint {
    width: 100%;
    height: auto;
    aspect-ratio: 1/1;
    background-color: var(--background-tertiary-color);
    border-radius: 0.5rem;
    margin-bottom: 0.5rem;
    display: flex;
    justify-content: center;
    align-items: center;
    text-align: center;
    font-size: 1.2rem;
    box-sizing: border-box;
    padding: 0.5rem;
}

.image-placeholder-skeleton {
    width: 100%;
    height: auto;
    background: linear-gradient(
        -45deg,
        var(--background-secondary-color) 0%,
        var(--background-secondary-color) 40%,
        var(--background-tertiary-color) 50%,
        var(--background-secondary-color) 60%,
        var(--background-secondary-color) 100%
    );
    animation: wave 1s linear infinite reverse;
    background-size: 600% 100%;
    border-radius: 0.5rem;
    margin-bottom: 0.5rem;
}

@keyframes wave {
    0% {
        background-position: 0 0;
    }
    100% {
        background-position: 100% 0;
    }
}

.image-placeholder-skeleton img.preview {
    width: 100%;
    height: 100%;
    object-fit: contain;
    box-sizing: border-box;
    padding: 0.5rem;
    border-radius: 1rem; /* 0.5 default plus padding */
    opacity: 0.5;
    filter: saturate(var(--config-preview-saturation)); /* compensate for opacity */
}

.resolution-selector-button .icon {
    font-size: 1.5rem;
    height: calc(var(--input-height) - 1rem);
    width: calc(var(--input-height) - 1rem);
    margin: 0.5rem;
}

/* resolution selector */
#resolution-selector-overlay {
    width: 100vw;
    height: 100vh;
    position: fixed;
    top: 0;
    left: 0;
    background-color: rgba(0, 0, 0, 0.5);
    z-index: 10;
    display: flex;
    justify-content: center;
    align-items: center;
}

#resolution-selector-overlay.hidden {
    display: none;
}

#resolution-selector {
    width: 90%;
    height: 50%;
    background-color: var(--background-tertiary-color);
    position: fixed;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: 11;
    border-radius: 0.5rem;
    padding: 1rem;
    box-sizing: border-box;
    display: flex;
    flex-direction: column;
    justify-content: space-evenly;
}

#resolution-selector.hidden {
    display: none;
}

.resolution-scale-buttons {
    display: flex;
    flex-direction: row;
    justify-content: space-evenly;
    gap: 1rem;
}

.resolution-scale-buttons input {
    display: none;
}

.resolution-scale-buttons label {
    background-color: var(--background-secondary-color);
    padding: 0.5rem;
    border-radius: 0.5rem;
    text-align: center;
    transition:
        background-color 0.25s ease,
        box-shadow 0.25s ease;
    cursor: pointer;
    box-shadow: 0 0 0.5rem var(--background-primary-color) inset;
}

.resolution-scale-buttons input:checked + label {
    background-color: var(--background-tertirary-color);
    box-shadow: 0 0 0.5rem var(--background-primary-color);
}

.resolution-buttons {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    gap: 1rem;
}

.resolution-button {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    background-color: var(--background-secondary-color);
    padding: 0.5rem;
    box-sizing: border-box;
    border-radius: 0.5rem;
    height: 5rem;
}

.resolution-label {
    font-weight: bold;
    text-align: center;
    font-size: 0.9rem;
}

.resolution-dimensions {
    font-size: 0.8rem;
    color: var(--text-secondary-color);
}
